package com.swing.camera.swing_camera

import android.annotation.SuppressLint
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.FlutterPlugin.FlutterPluginBinding
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding

/** SwingCameraPlugin */
@SuppressLint("KotlinNullnessAnnotation")
class SwingCameraPlugin : FlutterPlugin, ActivityAware {

    private var methodHandlerImpl: MethodHandlerImpl? = null
    private var flutterPluginBinding: FlutterPluginBinding? = null

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPluginBinding) {
        this.flutterPluginBinding = flutterPluginBinding
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPluginBinding) {
        flutterPluginBinding = null
    }

    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        methodHandlerImpl =
            flutterPluginBinding?.let {
                MethodHandlerImpl(
                    it.binaryMessenger,
                    binding.activity,
                    it.textureRegistry,
                )
            }
    }

    override fun onDetachedFromActivityForConfigChanges() {
        onDetachedFromActivity()
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {
        onAttachedToActivity(binding)
    }

    override fun onDetachedFromActivity() {
        if (methodHandlerImpl != null) {
            methodHandlerImpl!!.dispose()
            methodHandlerImpl = null
        }
    }
}
