import 'package:flutter/material.dart';
import 'package:swing_camera/swing_camera.dart';

class CameraScreen extends StatefulWidget {
  const CameraScreen({Key? key}) : super(key: key);

  @override
  State<CameraScreen> createState() => _CameraScreenState();
}

class _CameraScreenState extends State<CameraScreen> {
  late SwingCameraController _swingCameraController;

  @override
  void initState() {
    _swingCameraController = SwingCameraController();
    super.initState();
    startCamera();
  }

  void startCamera() async {
    await _swingCameraController.startCamera();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Camera'),
      ),
      body: SwingCameraView(
        controller: _swingCameraController,
      ),
    );
  }
}
